#include <avr/io.h>
#include <stdlib.h>
#include <util/delay.h>
#include <stdio.h>

//Define functions
//==========================================================
void io_init(void);                         //Initializes IO
void send_nibble(unsigned char __rs, unsigned char __data);

//==========================================================

int main (void)
{
    io_init();
    
	_delay_ms(15);
	send_nibble(0,0b0010);   //Set to 4 bit operation (note: 1 nibble operation)
	_delay_ms(5);
	
	send_nibble(0,0b0010);   //Function set, 4 bit
	send_nibble(0,0b1000);

	send_nibble(0,0b0000);   //Display ON, Cursor On, Cursor Blinking
	send_nibble(0,0b1111);

	send_nibble(0,0b0000);   //Clear Display
	send_nibble(0,0b0001);

	send_nibble(0,0b0000);  //Entry Mode, Increment cursor position, No display shift
	send_nibble(0,0b0110);

	send_nibble(1,0b0100);  //H
	send_nibble(1,0b1000);

	send_nibble(1,0b0110);  //e
	send_nibble(1,0b0101);

	send_nibble(1,0b0110);  //l
	send_nibble(1,0b1100);

	send_nibble(1,0b0110);  //l
	send_nibble(1,0b1100);

	send_nibble(1,0b0110);  //o
	send_nibble(1,0b1111);

	send_nibble(1,0b0010);  //Space
	send_nibble(1,0b0000);

	send_nibble(1,0b0101);  //w
	send_nibble(1,0b0111);

	send_nibble(1,0b0110);  //o
	send_nibble(1,0b1111);

	send_nibble(1,0b0111);  //r
	send_nibble(1,0b0010);

	send_nibble(1,0b0110);  //l
	send_nibble(1,0b1100);
	
	send_nibble(1,0b0110);  //d
	send_nibble(1,0b0100);

    return(0);
}



void io_init (void)
{
    /*
    PC 7: N/A
    PC 6: Reset
    PC 5: Enable
    PC 4: Register Select
    PC 3: Data 7
    PC 2: Data 6  
    PC 1: Data 5
    PC 0: Data 4   
    */
    
    DDRC = 0b00111111;
}


void send_nibble(unsigned char __rs, unsigned char __data)
{
	PORTC = (__rs<<4) | __data | 0b00100000;      // Set RS & Data. Set EN=High
	_delay_ms(1);
	PORTC = (__rs<<4) | __data;                   // Set RS & Data. Set EN=Low
	_delay_ms(1);
}
